local yorsahjID = "D810" --in hex since that's how game gives it
local bloodIDs = {
	["Hspell:104894"] = "1", --Dark
	["Hspell:104900"] = "2", --Cobalt
	["Hspell:104898"] = "3", --Acidic
	["Hspell:104896"] = "4", --Shadowed
	["Hspell:104897"] = "5", --Crimson
	["Hspell:104901"] = "6", --Glowing
}

local addonName, addon = ...
LibStub("AceAddon-3.0"):NewAddon(addon, addonName, "AceEvent-3.0")

function addon:OnInitialize()
	self:SetupDB()
	self:SetupOptions()
	self.summonedGlobules = {}
	self:SetEnabledState(self.db.global.enabled)
end

function addon:OnEnable()
	self:RegisterEvent("CHAT_MSG_RAID_BOSS_EMOTE")
end

function addon:CHAT_MSG_RAID_BOSS_EMOTE(event, message)
	local bossGUID = UnitGUID("boss1")
	if not bossGUID then return end --we aren't fighting anything, abort
	if bossGUID:sub(-12, -9) ~= yorsahjID then return end --we aren't fighting yorsahj, abort
	wipe(self.summonedGlobules)
	for spellID, color in pairs(bloodIDs) do
		if message:find(spellID) then
			self.summonedGlobules[#self.summonedGlobules+1] = color
		end
	end
	if ( #self.summonedGlobules ~= 3 and #self.summonedGlobules ~= 4) then return end --didnt find three/four globules, abort (should try to detect heroic mode)
	sort(self.summonedGlobules)
	local summonedGlobulesString = self.summonedGlobules[1]..self.summonedGlobules[2]..self.summonedGlobules[3]
	self.killGlobule = self.db.global[#self.summonedGlobules][summonedGlobulesString]
	self:OutputWarning()
end
			
function addon:OutputWarning()
	local announceSettings = self.db.global.announces
	if announceSettings.raid then
		SendChatMessage(self.killGlobule, "RAID")
	end
	if announceSetting.raidWarning then
		if IsRaidLeader("player") or IsRaidOfficer("player") then
			SendChatMessage(self.killGlobule, "RAID_WARNING")
		end
	end
	if announceSetting.privateRaidWarning then
		RaidNotice_AddMessage(RaidWarningFrame, self.killGlobule, ChatTypeInfo["RAID_WARNING"])
		PlaySoundFile("Sound\\Interface\\RaidWarning.wav")
	end
	if announceSetting.privateChatMessage then
		print(self.killGlobule)
	end
end